#pragma once
#include "resource.h"
#include "afxcmn.h"
#include "SceneTreeDialog.h"
#include "CameraControl.h"
#include "LightControl.h"
#include "ClassExampleViewport.h"
#include "afxwin.h"

class ClassExampleDlg : public CDialog
{
public:
  ClassExampleDlg(CWnd* pParent = NULL);

  enum { IDD = IDD_CLASSEXAMPLE_MAIN };

protected:
  virtual void DoDataExchange(CDataExchange* pDX);

protected:
  HICON m_hIcon;

  // Generated message map functions
  virtual BOOL OnInitDialog();
  afx_msg void OnPaint();
  afx_msg HCURSOR OnQueryDragIcon();
  DECLARE_MESSAGE_MAP()

private:
  void InitializeCameras();

  CameraControl      m_CameraControl;
  LightControl       m_LightControl; 

  UIWindow              m_MainUIWindow;
  ClassExampleViewport  m_MainViewport;
  
  UIWindow              m_CornerUIWindow;
  ClassExampleViewport  m_CornerViewport;

  afx_msg void OnTimer(UINT nIDEvent);
  afx_msg void OnBnClickedResetWorld();

public:
  BOOL m_ShowCameraControl;
  BOOL m_ShowLightControl;
  BOOL m_TriangleProblem;
  BOOL m_PerspectiveProblem;
  BOOL m_SilhouetteProblem;
  BOOL m_NormalProblem;
  BOOL m_TJunctionProblem;
  afx_msg void OnBnClickedShowCameralControl();
  afx_msg void OnBnClickedShowLightControl();
  afx_msg void OnBnClickedTriangleOrientation();
  afx_msg void OnBnClickedPerspectiveDistortion();
  afx_msg void OnBnClickedSilhouette();
  afx_msg void OnBnClickedNormalProblem();
  afx_msg void OnBnClickedTJunction();
};
