#pragma once
#include "resource.h"
#include "afxcmn.h"
#include "SceneNodeControl.h"
#include "PrimitiveControl.h"

class SceneTreeDialog : public CDialog
{
  DECLARE_DYNAMIC(SceneTreeDialog)

public:
  SceneTreeDialog(CWnd* pParent = NULL);   // standard constructor
  virtual ~SceneTreeDialog();

// Dialog Data
  enum { IDD = IDD_SCENETREE };

protected:
  void BuildSceneTree(SceneNode* pNode, HTREEITEM hParentNode = TVI_ROOT);
  virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

  DECLARE_MESSAGE_MAP()
private:
  CTreeCtrl m_SceneTree;

  class TreeNodeData
  {
  public:
    TreeNodeData()
    : m_pSceneNode(NULL)
    {}

    SceneNode* m_pSceneNode;
  };

  std::vector<TreeNodeData*> m_DataNodes;
  SceneNodeControl m_SceneNodeControl;
  PrimitiveControl m_PrimitiveControl;
public:
  virtual BOOL OnInitDialog();
  afx_msg void OnTvnSelchangedSceneTree(NMHDR *pNMHDR, LRESULT *pResult);
};
