#include "uwbgl_D3DArrowSceneNode.h"

using namespace UWBGL_D3D;

ArrowSceneNode::ArrowSceneNode()
{
	m_Body = new MeshPrimitive(eCylinderMesh);
	m_Body->SetDrawColor(D3DXCOLOR(0.6f, 0.95f, 0.6f, 0.0f));
  m_Body->DisableLighting();
	m_BodyNode = new SceneNode();
	m_BodyNode->SetPrimitive(m_Body);
	m_BodyNode->m_XForm.SetScaleTo(D3DXVECTOR3(0.025f, 0.025f, 0.5f));
	m_BodyNode->m_XForm.SetRotationToRadian(D3DXVECTOR3(M_PI/2.0f, 0.0f, 0.0f));
	m_BodyNode->m_XForm.SetTranslationTo(D3DXVECTOR3(0.0f, 0.42f, 0.0f));

	m_Head = new MeshPrimitive(eConeMesh);
  m_Head->SetDrawColor(D3DXCOLOR(0.95f, 0.2f, 0.2f, 0.0f));
  m_Head->DisableLighting();
	m_HeadNode = new SceneNode();
  m_HeadNode->SetPrimitive(m_Head);
	m_HeadNode->m_XForm.SetScaleTo(D3DXVECTOR3(0.08f, 0.08f, 0.08f));
	m_HeadNode->m_XForm.SetRotationToRadian(D3DXVECTOR3(M_PI/2.0f, 0.0f, 0.0f));
	m_HeadNode->m_XForm.SetTranslationTo(D3DXVECTOR3(0.0f, 0.84f, 0.0f));

  InsertChildNode(m_BodyNode);
	InsertChildNode(m_HeadNode);
}

void
ArrowSceneNode::SetArrowColor(
	const D3DXCOLOR &h,	// head color
	const D3DXCOLOR &b 	// body color
)
{
	m_Head->SetDrawColor(h);
	m_Body->SetDrawColor(b);
}
