#pragma once

#include "uwbgl_D3DFillablePrimitive.h"

// CirclePrimitive only allows two vertex
//   First Position  is the center
//   Second Position is one point on the circumfrance
namespace UWBGL_D3D
{
  class CirclePrimitive : public FillablePrimitive
  {
  protected:
    // Override from DrawablePrimitive
    virtual void DrawPrimitiveGeometry();

  public:
    virtual ~CirclePrimitive();
    CirclePrimitive();
    CirclePrimitive(const D3DXVECTOR3& center, float radius);
    CirclePrimitive(float radius);
    
    // override from PrimitiveBase
    virtual void GetColliderList(ColliderList&);

    // These are from DrawablePrimitives
    virtual void SetFirstVertex(const D3DXVECTOR3 &p);
    virtual void AppendVertex(const D3DXVECTOR3 &p);
    virtual void MovePrimitiveTo(const D3DXVECTOR3 &);

    void  SetCircle(const D3DXVECTOR3 &p, float);
    void  SetRadius(float r);
    const D3DXVECTOR3* GetCenter() const;
    float GetRadius();
  };
};
