// UW Bothell Graphics Library Copyright (c) 2004 University of Washington Bothell
// Authors: Kelvin Sung, Steve Baer
// The accompanying library supports CSS Graphics courses taught at UW-Bothell
// See: http://courses.washington.edu/css450/
//      http://courses.washington.edu/css451/
/////////////////////////////////////////////////////////////////////////////////////////

/// uwbgl_defines.h: Preprocessor symbols and macros used by the Graphics Library.
#pragma once

#include "../uwbgl_Defines.h"
#include <vector>

/// uwbgl_D3DSystem.h: System specific header files for the different flavors of the graphics
///                 library. Based on which project you are using, support will be added
///                 for MFC, WTL, OpenGL, and Direct3D

/// Direct 3D include file (Remember to link with d3d9.lib)
#include <d3d9.h>      
/// For D3DX - classes (e.g. D3DX_VECTOR, etc.)
#include <d3dx9mesh.h> 
/// For D3DX - math classes ... (Remember to link with d3dx9.lib)
#include <d3dx9math.h> 
#pragma comment(lib, "d3d9.lib")
#pragma comment(lib, "d3dx9.lib")

typedef std::vector<D3DXVECTOR3> D3DVertexList;

// System pre-defined Mesh index (in the resource table, use in Viewport_ResourceSupport.cpp
#define eCylinderMesh   100
#define eConeMesh       101
#define eSphereMesh     102
#define eBoxMesh        103
#define eCarMesh        104
#define eShusuiMesh     105
#define eBigShipMesh    106
#define eTigerMesh      107
#define eTeapotMesh     108
#define eHiResMesh      109
#define eOpenConeMesh   110
             

typedef std::vector<void*>        ResourceTable;
