#pragma once
#include "uwbgl_D3DShadablePrimitive.h"

//
// lines are shadeable (you can shade them as gouraud shading)
//
namespace UWBGL_D3D
{
  class LinePrimitive : public ShadablePrimitive
  {
  protected:
    // lines has no special attributes

    // override from IPrimitive
    virtual void DrawPrimitiveGeometry();
  public:
    LinePrimitive();
    virtual ~LinePrimitive();

    void SetEnds(float pt0_x, float pt0_y, float pt0_z, float pt1_x, float pt1_y, float pt1_z);
    // override from PrimitiveBase
    // virtual void GetColliderList(ColliderList&);

    // override from DrawablePrimitive
    virtual void SetFirstVertex(const D3DXVECTOR3 &p);
    virtual void AppendVertex(const D3DXVECTOR3&);
    // to make sure we never exceed two vertices

    // override from DrawablePrimitive
    virtual void MovePrimitiveTo(const D3DXVECTOR3 &d);
  };
};
