 		
#include "uwbgl_D3DGraphicsSystem.h"
#include "uwbgl_D3DDeviceVertexFormat.h"
#include "uwbgl_D3DMeshPrimitive.h"
#include "uwbgl_D3DCollider.h"

using namespace UWBGL_D3D;


ImplementSimplePrimitiveAttr(MeshPrimitive, int, MeshIndex)

void MeshPrimitive::GetColliderList(ColliderList &list) 
{
  LPDIRECT3DDEVICE9 d3dDevice = GraphicsSystem::GetSystem().GetActiveDevice();
	if (d3dDevice == NULL)
		return;

  ResourceTable *t = GraphicsSystem::GetSystem().GetActiveResourceTable();
  if (t != NULL) {
      RawMesh *m = (RawMesh *) ((*t)[m_MeshIndex]);
      if (m != NULL) {
          Collider c(m->MeshCenter(), m->MeshRadius());
          list.Append(c);
      }
  }
}

void MeshPrimitive::DrawPrimitiveGeometry()
{
	LPDIRECT3DDEVICE9 d3dDevice = GraphicsSystem::GetSystem().GetActiveDevice();
  if (d3dDevice == NULL) return;

  ID3DXMatrixStack* pStack =  GraphicsSystem::GetSystem().GetWorldStack();
  pStack->Push();

      m_XForm.SetUpD3DXformStack( pStack );
      d3dDevice->SetTransform(D3DTS_WORLD,pStack->GetTop());

        ResourceTable *t = GraphicsSystem::GetSystem().GetActiveResourceTable();
        if (t != NULL) 
        {
            RawMesh *m = (RawMesh *) ((*t)[m_MeshIndex]);
            if (m != NULL)
                m->DrawNormalizedMesh( !LightingIsEnabled(), TextureIsEnabled(), GetDrawColor(), m_Material.GetD3DMaterial() );
        }
  pStack->Pop();
  d3dDevice->SetTransform(D3DTS_WORLD,pStack->GetTop());
}