#pragma once

#include "uwbgl_D3DDrawablePrimitive.h"

//
// Point uses the 
//
// 		m_FirstPosition 
//
// 	defined in DrawablePrimitive to define the geometry of a point.
//	at all times, the m_SecondPosition is ignored
//

namespace UWBGL_D3D {

  class PointPrimitive : public DrawablePrimitive {

	  SimplePrimitiveAttr(float, PointSize)

	protected:
		
			//
			// Override from DrawablePrimitive
			//
		virtual void DrawPrimitiveGeometry();
		virtual void SetPrimitiveAttributesForDrawing();

	public:

			// override from PrimitiveBase
		virtual void GetColliderList(ColliderList &);

			//
			// override from DrawablePrimitive
		virtual void AppendVertex(const D3DXVECTOR3&);
		virtual void MovePrimitiveTo(const D3DXVECTOR3 &);

		virtual ~PointPrimitive();
		PointPrimitive();
  };
};
