#include "uwbgl_D3DPrimitiveBase.h"
#include "uwbgl_D3DCollider.h"
#include "uwbgl_D3DSceneNode.h"

using namespace UWBGL_D3D;

ImplementBoolPrimitiveAttr(PrimitiveBase, Visibility)
ImplementBoolPrimitiveAttr(PrimitiveBase, ShowColliders)

PrimitiveBase::PrimitiveBase()
: m_Visibility(true)
, m_ShowColliders(false)
, m_pParentSceneNode(NULL)
{
}

PrimitiveBase::~PrimitiveBase()
{
}

void PrimitiveBase::SetParentNode(SceneNode* pSceneNode)
{
  m_pParentSceneNode = pSceneNode;
}
	
bool PrimitiveBase::ShouldDrawPrimitive() { return VisibilityIsEnabled(); }


	// Since we never cache colliders anywhere, this means
	// if user ask for collider list (GetCollidreList()) and then
	// switch on DrawColliders(), we will be computing colliders twice
	// For now, we will live with this, potentially very badly, inefficiency.
	//
	// What we gain by putting up with this inefficiency is, we don't have to
	// worry about in-consistency, we know our list is always up-to-date. This
	// is the major advantage of not caching informaiotn.
void PrimitiveBase::DrawColliders()
{
	ColliderList list;
	GetColliderList(list);
	list.DrawColliders();
}
