#include "uwbgl_D3DGraphicsSystem.h"
#include "uwbgl_D3DShadablePrimitive.h"

using namespace UWBGL_D3D;

ImplementSimplePrimitiveAttr(ShadablePrimitive, WORD,  ShadedMode)


ShadablePrimitive::~ShadablePrimitive() {}

ShadablePrimitive::ShadablePrimitive()
: m_ShadedMode(D3DSHADE_GOURAUD)
{
}

void ShadablePrimitive::SetPrimitiveAttributesForDrawing()
{
	LPDIRECT3DDEVICE9 device = GraphicsSystem::GetSystem().GetActiveDevice();
	if (device == NULL) return;

	// Calls the parent class to do its work
	DrawablePrimitive::SetPrimitiveAttributesForDrawing();

	device->SetRenderState(D3DRS_SHADEMODE, m_ShadedMode);
}

