// UW Bothell Graphics Library Copyright (c) 2004 University of Washington Bothell
// Authors: Kelvin Sung, Steve Baer
// The accompanying library supports CSS Graphics courses taught at UW-Bothell
// See: http://courses.washington.edu/css450/
//      http://courses.washington.edu/css451/
/////////////////////////////////////////////////////////////////////////////////////////

// uwbgl_D3D_Lib3.h - Main Include file for version 3 of the UWB Graphics Library
// Include this single header file in your projects to add support for the library.

// NOTE: There is absolutely no library specific windowing functionality in this library
//       Include the MFC, WTL, ... specific UWBGL libraries into your projects to add
//       windowing support.

#pragma once

#include "uwbgl_Defines.h"   //Common headers, symbols, and macros
#include "uwbgl_Functions.h"
#include "uwbgl_Valuator.h"


#include "D3D_4/uwbgl_D3DDefines.h"            //Direct3D Specific headers, symbols and macros
#include "D3D_4/uwbgl_D3DGraphicsSystem.h"    //system specific headers (shared between _1 _2 and _3)
#include "D3D_4/uwbgl_D3DViewport.h"          //D3D specific Viewport base class

#include "D3D_4/uwbgl_D3DXFormInfo.h"
#include "D3D_4/uwbgl_D3DSceneNode.h"
#include "D3D_4/uwbgl_D3DCollider.h"
#include "D3D_4/uwbgl_D3DDrawablePrimitive.h"
#include "D3D_4/uwbgl_D3DDrawablePrimitiveList.h"
#include "D3D_4/uwbgl_D3DShadablePrimitive.h"
#include "D3D_4/uwbgl_D3DFillablePrimitive.h"
#include "D3D_4/uwbgl_D3DPointPrimitive.h"
#include "D3D_4/uwbgl_D3DLinePrimitive.h"
#include "D3D_4/uwbgl_D3DCirclePrimitive.h"
#include "D3D_4/uwbgl_D3DRectanglePrimitive.h"
#include "D3D_4/uwbgl_D3DMaterial.h"
#include "D3D_4/uwbgl_D3DLight.h"
#include "D3D_4/uwbgl_D3DPointLight.h"
#include "D3D_4/uwbgl_D3DSpotLight.h"
#include "D3D_4/uwbgl_D3DDirectionalLight.h"

// New in D3D_4
#include "D3D_4/uwbgl_D3DMeshPrimitive.h"
#include "D3D_4/uwbgl_D3DArrowSceneNode.h"
#include "D3D_4/uwbgl_D3DAxisFrameSceneNode.h"
#include "D3D_4/uwbgl_D3DCamera.h"

using namespace UWBGL_D3D;