#include "uwbgl_Valuator.h"

Valuator::Valuator():
  m_Min(0.0f),
  m_Max(0.0f),
  m_MinValue(0.0f),
  m_Scale(0.0f)
{}


void Valuator::InitializeValuator(float minInput, float maxInput, float minScale, float maxScale)
{
  m_Min = minInput;
  m_Max = maxInput;
  m_MinValue = minScale;
  m_Scale = ((maxScale-minScale)/(m_Max-m_Min));
}

float Valuator::GetScaleValue(float v) const
{
  if (v < m_Min) v = m_Min;
  else if (v > m_Max) v = m_Max;
        
  float returnV = m_MinValue + (m_Scale * (v - m_Min));
  return returnV;
}
