#include "StdAfx.h"
#include "World.h"

World theWorld;

World::World() : 
		m_DirLgt(0),
		m_PointLgt(1),
		m_SpotLgt(2),
		m_DrawDistortion(false),
		m_DrawTriangleOrientation(false),
		m_DrawTjunction(false),
		m_DrawNormalProblem(false),
		m_DrawSilhouette(false),
    
    m_bShowCamera(true),
    m_bShowCameraRail(false)
{
	
	m_MainFrame.m_XForm.SetScaleTo(5);

	m_DirLgt.SwitchOnLight();
	m_DirLgt.SetPosition(0.0f, 10.0f, 0.0f);
	m_DirLgt.SetDirection(0.0f, -1.0f, 0.0f);
	m_DirLgt.SetDiffuse(1.0f, 0.2f, 0.2f);

	m_PointLgt.SwitchOffLight();
	m_PointLgt.SetPosition(0.0f, 10.0f, 0.0f);

	m_SpotLgt.SwitchOffLight();
	m_SpotLgt.SetPosition(0.0f, 10.0f, 0.0f);
	m_SpotLgt.SetDirection(0.0f, -1.0f, 0.0f);
}

void 
World::DrawWorld()
{

	m_PointLgt.SetLightToDevice();
	m_DirLgt.SetLightToDevice();
	m_SpotLgt.SetLightToDevice();

	m_PointLgt.DrawLight();
	m_DirLgt.DrawLight();
	m_SpotLgt.DrawLight();

	m_MainFrame.DrawNode();


	DrawPerspectiveDistortion();
	DrawTriangleOrientation();
	DrawTjunctionProblem();
	DrawNormalProblem();
	DrawSilhouetteProblem();

}
