#pragma once

class World {
	private:
		// control
		//
		DirectionalLight				m_DirLgt;
		PointLight							m_PointLgt;
		SpotLight								m_SpotLgt;

		AxisFrameSceneNode			m_MainFrame;

		void DrawPerspectiveDistortion();
		void DrawTriangleOrientation();
		void DrawTjunctionProblem();
		void DrawNormalProblem();
		void DrawSilhouetteProblem();

	public:
		World();
    void UpdateWorld() {}
		void DrawWorld();

		bool		m_DrawDistortion;
		bool		m_DrawTriangleOrientation;
		bool		m_DrawTjunction;
		bool		m_DrawNormalProblem;
		bool		m_DrawSilhouette;

    bool    m_bShowCamera;
    bool    m_bShowCameraRail;

		Light*	GetSpotLight() { return &m_SpotLgt; }
		Light*	GetDirectionalLight() { return &m_DirLgt; }
		Light*	GetPointLight() { return &m_PointLgt; }
};

extern World theWorld;