#include "StdAfx.h"
#include "World.h"
#include "SetDeviceVertex.h"

void World::DrawNormalProblem()
{

	if (!m_DrawNormalProblem) 
		return;

	// 
	// Draw four rectangles with 8 triangles, connected along the long side
	// center two rectangles forms a perfect equalateral triangle (norm points up!)
	//
	// Use stripe: remember ... the order ...
	// 
	// 

	DeviceVertexFormat v[10];
					// xyz                nx,ny,nz,
	SetVertex(v[0], -10, 0, 8, 		-1, 1, 0)
	SetVertex(v[2],  -5, 8, 8, 		 0, 1, 0)
	SetVertex(v[4],   0, 0, 8, 		 0, 1, 0)
	SetVertex(v[6],   5, 8, 8, 		 0, 1, 0)
	SetVertex(v[8],  10, 0, 8, 		 1, 1, 0)

	SetVertex(v[1], -10, 0,-8, 		-1, 1, 0)
	SetVertex(v[3],  -5, 8,-8, 		 0, 1, 0)
	SetVertex(v[5],   0, 0,-8, 		 0, 1, 0)
	SetVertex(v[7],   5, 8,-8, 		 0, 1, 0)
	SetVertex(v[9],  10, 0,-8,		 1, 1, 0)


	Material m;
	m.SetDiffuse(0.7f);
	m.SetAmbient(0.0f);
	m.SetSpecular(1.0f, 1.0f, 1.0f);
	m.SetEmissive(0.0f);
	m.SetPower(100.0f);

	LPDIRECT3DDEVICE9 device = GraphicsSystem::GetSystem().GetActiveDevice();

	device->SetRenderState(D3DRS_LIGHTING, TRUE);
	device->SetMaterial( m.GetD3DMaterial() );

	device->SetFVF(DeviceVertexFormatCode);
	device->DrawPrimitiveUP(D3DPT_TRIANGLESTRIP, 8, (CONST void*)v, sizeof(DeviceVertexFormat));
}
