#include "StdAfx.h"
#include "World.h"
#include "SetDeviceVertex.h"

void World::DrawPerspectiveDistortion()
{

	if (!m_DrawDistortion) 
		return;

	// Just draw a large 4-vertex triangle strip with black to white
	// Gouraud shading
	// and move the camera around to see the problem

	DeviceVertexFormat v[4];
														// xyz         					r,g,b,    					nx,ny,nz,
	SetVertexWithColor(v[0], -20.0f, 0.0f,  30.0f,    0.0f, 0.0f, 0.0f,		0.0f, 1.0f, 0.0f)
	SetVertexWithColor(v[1], -20.0f, 0.0f, -30.0f,    1.0f, 1.0f, 1.0f,		0.0f, 1.0f, 0.0f)
	SetVertexWithColor(v[2],  20.0f, 0.0f,  30.0f,    0.0f, 0.0f, 0.0f,		0.0f, 1.0f, 0.0f)
	SetVertexWithColor(v[3],  20.0f, 0.0f, -30.0f,    1.0f, 1.0f, 1.0f,		0.0f, 1.0f, 0.0f)

	LPDIRECT3DDEVICE9 device = GraphicsSystem::GetSystem().GetActiveDevice();

	device->SetRenderState(D3DRS_LIGHTING, FALSE);
	device->SetFVF(DeviceVertexFormatCode);
	device->DrawPrimitiveUP(D3DPT_TRIANGLESTRIP, 2, (CONST void*)v, sizeof(DeviceVertexFormat));
}
