#include "StdAfx.h"
#include "World.h"
#include "SetDeviceVertex.h"

void World::DrawTjunctionProblem()
{

	if (!this->m_DrawTjunction) 
		return;

	// 
	// Draw two triangles that are exactly the same, only one of the tirangles
	// have 4 vertices (the extra one is internal to the triangle)
	//
	//
	// Use Fan: remember ...
	//
	//          v0, v1, v2 is one 
	//          v0, v2, v3 is the next etc.
	// 
	// 

	DeviceVertexFormat va[4];
	DeviceVertexFormat vb[4];
					// xyz             r,g,b,      nx,ny,nz,
	SetVertexWithColor(va[0], -5.0f, 0.0f, 10.0f,    1.0f, 1.0f,  1.0f,		0.0f, 1.0f, 0.0f)
	SetVertexWithColor(va[1],-10.0f, 0.0f,  0.0f,    0.0f, 0.0f,  0.0f,		0.0f, 1.0f, 0.0f)
	SetVertexWithColor(va[2], -5.0f, 0.0f,  0.0f,    0.51f,0.51f,0.51f,		0.0f, 1.0f, 0.0f)
	SetVertexWithColor(va[3],  0.0f, 0.0f,  0.0f,    1.0f, 0.0f,  0.0f,		0.0f, 1.0f, 0.0f)

	DeviceVertexFormat va1[3];
	SetVertexWithColor(va1[0], -5.0f, 0.0f,-10.0f,   1.0f, 1.0f, 1.0f,		0.0f, 1.0f, 0.0f)
	SetVertexWithColor(va1[1],-10.0f, 0.0f,  0.0f,   0.0f, 0.0f, 0.0f,		0.0f, 1.0f, 0.0f)
	SetVertexWithColor(va1[2],  0.0f, 0.0f,  0.0f,   1.0f, 0.0f, 0.0f,		0.0f, 1.0f, 0.0f)


	SetVertexWithColor(vb[0],  5.0f, 0.0f, 10.0f,    1.0f, 1.0f, 1.0f,		0.0f, 1.0f, 0.0f)
	SetVertexWithColor(vb[1],  0.0f, 0.0f,  0.0f,    0.0f, 0.0f, 0.0f,		0.0f, 1.0f, 0.0f)
	SetVertexWithColor(vb[2], 10.0f, 0.0f,  0.0f,    1.0f, 0.0f, 0.0f,		0.0f, 1.0f, 0.0f)

	DeviceVertexFormat vb1[3];
	SetVertexWithColor(vb1[0],  5.0f, 0.0f,-10.0f,    1.0f, 1.0f, 1.0f,		0.0f, 1.0f, 0.0f)
	SetVertexWithColor(vb1[1],  0.0f, 0.0f,  0.0f,    0.0f, 0.0f, 0.0f,		0.0f, 1.0f, 0.0f)
	SetVertexWithColor(vb1[2], 10.0f, 0.0f,  0.0f,    1.0f, 0.0f, 0.0f,		0.0f, 1.0f, 0.0f)


	// The fix here is, ofcourse, of va is what we want, then va1 should also have
	// 4 vertices, with one in the middle of va1 triangle, matching that of va.
	//
	// If va is _NOT_ what we want, then we should remove the va[2] vertex. <- this is a T-Junction


	LPDIRECT3DDEVICE9 device = GraphicsSystem::GetSystem().GetActiveDevice();
	device->SetRenderState(D3DRS_LIGHTING, FALSE);
	device->SetFVF(DeviceVertexFormatCode);
	
	device->DrawPrimitiveUP(D3DPT_TRIANGLEFAN, 2, (CONST void*)va, sizeof(DeviceVertexFormat));
	device->DrawPrimitiveUP(D3DPT_TRIANGLEFAN, 1, (CONST void*)va1, sizeof(DeviceVertexFormat));

	device->DrawPrimitiveUP(D3DPT_TRIANGLEFAN, 1, (CONST void*)vb, sizeof(DeviceVertexFormat));
	device->DrawPrimitiveUP(D3DPT_TRIANGLEFAN, 1, (CONST void*)vb1, sizeof(DeviceVertexFormat));
	
}
