#include "StdAfx.h"
#include "World.h"
#include "SetDeviceVertex.h"

void World::DrawTriangleOrientation()
{

	if (!m_DrawTriangleOrientation) 
		return;

	// 
	//  Draw these quads, one with triangle cutting through horizontally, 
	// the other with tirnalge cutting through vertically.
	//
	//  in both quads, black vertex at horizontal, and white vertices at verticle
	//
	// Remember: with Fan, 
	//
	//          v1, v2, v3 is one 
	//          v2, v3, v4 is the next etc.
	// 
	// 

	DeviceVertexFormat va[4];
	DeviceVertexFormat vb[4];
																	// xyz             r,g,b,      					nx,ny,nz,
	SetVertexWithColor(va[0], -5.0f, 0.0f,  5.0f,      0.0f, 0.0f, 0.0f,		0.0f, 1.0f, 0.0f)
	SetVertexWithColor(va[1],  0.0f, 0.0f,  0.0f,      1.0f, 1.0f, 1.0f,		0.0f, 1.0f, 0.0f)
	SetVertexWithColor(va[2],  0.0f, 0.0f, 10.0f,      1.0f, 1.0f, 1.0f,		0.0f, 1.0f, 0.0f)
	SetVertexWithColor(va[3],  5.0f, 0.0f,  5.0f,      0.0f, 0.0f, 0.0f,		0.0f, 1.0f, 0.0f)

	SetVertexWithColor(vb[0],  0.0f, 0.0f,  0.0f,      1.0f, 1.0f, 1.0f,		0.0f, 1.0f, 0.0f)
	SetVertexWithColor(vb[1], -5.0f, 0.0f, -5.0f,      0.0f, 0.0f, 0.0f,		0.0f, 1.0f, 0.0f)
	SetVertexWithColor(vb[2],  5.0f, 0.0f, -5.0f,      0.0f, 0.0f, 0.0f,		0.0f, 1.0f, 0.0f)
	SetVertexWithColor(vb[3],  0.0f, 0.0f, -10.0f,     1.0f, 1.0f, 1.0f,		0.0f, 1.0f, 0.0f)


	

	LPDIRECT3DDEVICE9 device = GraphicsSystem::GetSystem().GetActiveDevice();

	device->SetRenderState(D3DRS_LIGHTING, FALSE);
	device->SetFVF(DeviceVertexFormatCode);
	device->DrawPrimitiveUP(D3DPT_TRIANGLESTRIP, 2, (CONST void*)va, sizeof(DeviceVertexFormat));
	device->DrawPrimitiveUP(D3DPT_TRIANGLESTRIP, 2, (CONST void*)vb, sizeof(DeviceVertexFormat));
	
}
